from typing import Any, Dict, List, Tuple, overload

from ._PenaltyManager import PenaltyManager
from ._ProblemData import ProblemData
from ._XorShift128 import XorShift128

class Individual:
    @overload
    def __init__(
        self,
        data: ProblemData,
        penalty_manager: PenaltyManager,
        rng: XorShift128,
    ) -> None: ...
    @overload
    def __init__(
        self,
        data: ProblemData,
        penalty_manager: PenaltyManager,
        routes: List[List[int]],
    ) -> None: ...
    def cost(self) -> int: ...
    def get_neighbours(self) -> List[Tuple[int, int]]: ...
    def get_routes(self) -> List[List[int]]: ...
    def has_excess_capacity(self) -> bool: ...
    def has_time_warp(self) -> bool: ...
    def is_feasible(self) -> bool: ...
    def num_routes(self) -> int: ...
    def __copy__(self) -> Individual: ...
    def __deepcopy__(self, memo: Dict) -> Individual: ...
    def __hash__(self) -> int: ...
    def __eq__(self, other: Any) -> bool: ...
    def __str__(self) -> str: ...
